Imports System.Data
Imports System.Data.OleDb
Imports System.Data.SqlClient

Public Class MultiTableForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents btnTwoTables As System.Windows.Forms.Button
    Friend WithEvents DataGrid1 As System.Windows.Forms.DataGrid
    Friend WithEvents DataGrid2 As System.Windows.Forms.DataGrid
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btnTwoTables = New System.Windows.Forms.Button()
        Me.DataGrid1 = New System.Windows.Forms.DataGrid()
        Me.DataGrid2 = New System.Windows.Forms.DataGrid()
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.DataGrid2, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'btnTwoTables
        '
        Me.btnTwoTables.Location = New System.Drawing.Point(8, 16)
        Me.btnTwoTables.Name = "btnTwoTables"
        Me.btnTwoTables.Size = New System.Drawing.Size(96, 40)
        Me.btnTwoTables.TabIndex = 0
        Me.btnTwoTables.Text = "Read two Tables"
        '
        'DataGrid1
        '
        Me.DataGrid1.Anchor = ((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.DataGrid1.DataMember = ""
        Me.DataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText
        Me.DataGrid1.Location = New System.Drawing.Point(120, 16)
        Me.DataGrid1.Name = "DataGrid1"
        Me.DataGrid1.Size = New System.Drawing.Size(504, 136)
        Me.DataGrid1.TabIndex = 1
        '
        'DataGrid2
        '
        Me.DataGrid2.Anchor = (((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.DataGrid2.DataMember = ""
        Me.DataGrid2.HeaderForeColor = System.Drawing.SystemColors.ControlText
        Me.DataGrid2.Location = New System.Drawing.Point(120, 160)
        Me.DataGrid2.Name = "DataGrid2"
        Me.DataGrid2.Size = New System.Drawing.Size(504, 136)
        Me.DataGrid2.TabIndex = 2
        '
        'MultiTableForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(7, 17)
        Me.ClientSize = New System.Drawing.Size(632, 301)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.DataGrid2, Me.DataGrid1, Me.btnTwoTables})
        Me.Font = New System.Drawing.Font("Microsoft Sans Serif", 11.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Name = "MultiTableForm"
        Me.Text = "MultiTableForm"
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.DataGrid2, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' ensure that only one constant is -1
#Const OLEDBBIBLIO = 0
#Const OLEDBPUBS = 0
#Const SQLPUBS = -1

    Dim ds As New DataSet()

    ' smart way to read master-detail tables

    Private Sub btnTwoTables_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTwoTables.Click

        ' NOTE: to simplify the code and make it as generic as possible, we assume that
        ' the first column in the child table is its foreign key.

#If OLEDBBIBLIO Then
        Dim pubSql As String = "SELECT PubId, Name, City FROM Publishers"
        Dim titSql As String = "SELECT PubId, ISBN, Title, [Year Published] FROM Titles"
        Dim joinSql As String = "SELECT Publishers.PubId, Name, City, ISBN, Title, [Year Published] FROM Publishers INNER JOIN Titles ON Publishers.PubId=Titles.PubId WHERE State='MA' AND [Year Published] > 1991 ORDER BY Publishers.PubID"

        Dim cn As New OleDbConnection(BiblioConnString)
        Dim pubDa As New OleDbDataAdapter(pubSql, cn)
        Dim titDa As New OleDbDataAdapter(titSql, cn)
        Dim joinDa As New OleDbDataAdapter(joinSql, cn)
#ElseIf OLEDBPUBS Then
        Dim pubSql As String = "SELECT pub_id, pub_name, city FROM Publishers"
        Dim titSql As String = "SELECT pub_id, title_id, title, pubdate FROM Titles"
        Dim joinSql As String = "SELECT Publishers.pub_id, pub_name, city, title_id, title, pubdate FROM Publishers INNER JOIN Titles ON Publishers.pub_id=Titles.pub_id WHERE country='USA' AND pubdate>'10/1/1991' ORDER BY Publishers.pub_id"

        Dim cn As New OleDbConnection(OledbPubsConnString)
        Dim pubDa As New OleDbDataAdapter(pubSql, cn)
        Dim titDa As New OleDbDataAdapter(titSql, cn)
        Dim joinDa As New OleDbDataAdapter(joinSql, cn)
#ElseIf SQLPUBS Then
        Dim pubSql As String = "SELECT pub_id, pub_name, city FROM Publishers"
        Dim titSql As String = "SELECT pub_id, title_id, title, pubdate FROM Titles"
        Dim joinSql As String = "SELECT Publishers.pub_id, pub_name, city, title_id, title, pubdate FROM Publishers INNER JOIN Titles ON Publishers.pub_id=Titles.pub_id WHERE country='USA' AND pubdate>'10/1/1991' ORDER BY Publishers.pub_id"

        Dim cn As New SqlConnection(SqlPubsConnString)
        Dim pubDa As New SqlDataAdapter(pubSql, cn)
        Dim titDa As New SqlDataAdapter(titSql, cn)
        Dim joinDa As New SqlDataAdapter(joinSql, cn)
#End If

        ' Open the connection.
        cn.Open()

        ' Create the master and the detail table.
        Dim pubDt As DataTable = ds.Tables.Add("Publishers")
        Dim titDt As DataTable = ds.Tables.Add("Titles")

        ' Execute the JOIN operation into on the detail DataTable.
        ' (it will create a table with additional columns from the master table)
        joinDa.Fill(titDt)

        ' Fill the schema of the master table.
        pubDa.FillSchema(pubDt, SchemaType.Mapped)

        ' This variable holds the last value found in the master table.
        Dim keyValue As String

        ' Extract unique foreign key values from child table.
        Dim i As Integer
        Dim dr As DataRow

        For Each dr In titDt.Rows
            ' If we haven't seen this key value, create a new record in the master table.
            If dr(0).ToString <> keyValue Then
                ' Remember the new key value.
                keyValue = dr(0).ToString
                ' Add a new record.
                Dim pubRow As DataRow = pubDt.NewRow
                ' Copy only the fields that belong to the master table.
                For i = 0 To pubDt.Columns.Count - 1
                    pubRow(i) = dr(i)
                Next
                pubDt.Rows.Add(pubRow)
            End If
        Next

        ' removing columns belonging to the master table, but leave the foreign key
        ' (it is the 0-th column)
        For i = pubDt.Columns.Count - 1 To 1 Step -1
            titDt.Columns.RemoveAt(i)
        Next

        ' Now we can fill the schema of the child table and close the connectin.
        titDa.FillSchema(titDt, SchemaType.Mapped)
        cn.Close()

        ' Add the relation manually.
        ' (Note that this statement is based on the assumption that foreign key is the
        '  first column in the child table)
        ds.Relations.Add("PubTitles", pubDt.Columns(0), titDt.Columns(0))

        ' Bind to the DataGrid controls.
        DataGrid1.DataSource = pubDt
        DataGrid2.DataSource = titDt
    End Sub
End Class
